//by Shane Tolmie (c)2001 from http://www.microchipC.com/
//for Microchip PIC16F87x
//Hi-Tech C v7.86pl3 http://www.htsoft.com/

//aim: demonstrate how to output decimals to the default output routine (ie: putch())
//three methods are shown, printf(), putdec(), and putdec_long_to_device()

#include <pic.h>

#include "always.h"
#include "putdec.h"
#include "putdec.c"

unsigned char output[10];
unsigned char output_index=0;

void putch_to_device(unsigned char c)
{
  output[output_index++]=c;
}

void reset(void)
{
  unsigned char c;
  
  output_index=0;
  for (c=0;c<10;c++) {
    output[c]=0;
  }
}

#define breakpoint asm("nop")

main()
{

  //note: one could also use printf("%d") and define putch(), but these routines shown
  //below are smaller

  reset();  //zeros array output[]
  //puts result in array output[], see putch_to_device() called by putdec_to_device()  
  putdec(12345678);  
  breakpoint; //put a breakpoint here, and view array output[]
              //view output[] as ascii. If output is address 0x21, 
              //type 0x22 for output[1], 0x23 for output[2] etc in MPLab watch window (see output.wat)
              
  reset();  
  putdec_long_to_device(7654321);
  breakpoint;
}
